#include "headers.h"
#include "init.h"
#include "xpm/forth.xpm"

CMainFrame* pframeMain = NULL;

CMainFrame::CMainFrame(wxWindow* parent) : CMainFrameBase(parent)
{
	SetIcon(wxICON(forth));
    int pnWidths[3] = { 160, 200, 500 };
    m_statusBar->SetFieldsCount(3, pnWidths);
}

CMainFrame::~CMainFrame()
{
    pframeMain = NULL;
}

void CMainFrame::OnClose(wxCloseEvent& event)
{
        Destroy();
        CreateThread(Shutdown, NULL);
}

void CMainFrame::OnPaintListCtrl(wxPaintEvent& event)
{  unsigned short nn;
    event.Skip();
    nn=*(short*)STR_ZTYPE;

    if(STR_ZTYPE)
    {
    	if( nn < 4 )
    	{	m_statusBar->SetStatusText(  &STR_ZTYPE[2] , nn );
    	}else
    	{
    		m_forth->SetInsertionPointEnd();
    		m_forth->AppendText(STR_ZTYPE);
    	}
    	STR_ZTYPE=NULL;
    }
}

char volatile KEY_VARR;

void CMainFrame::OnKeyDown(wxKeyEvent& event)
{
    event.Skip();
   	KEY_VAR = event.GetKeyCode();
    if (KEY_VAR == '\r')
    {  long int xx, yy;
        m_forth->PositionToXY(m_forth->GetInsertionPoint(),&xx,&yy);
    	memcpy( (void*) TermOutBuff,m_forth->GetLineText(yy).c_str(),257);
    	m_forth->SetInsertionPointEnd();
    }

}

void CMainFrame::OnMenuFileExit(wxCommandEvent& event)
{
	Close(true);
}

void CMainFrame::OnMenuHelpAbout(wxCommandEvent& event)
{
    CAboutDialog dialog(this);
    dialog.ShowModal();
}

void CMainFrame::OnEdit(wxCommandEvent& event)
{
    CEditDialog dialog(this);
    dialog.ShowModal();
}

CAboutDialog::CAboutDialog(wxWindow* parent) : CAboutDialogBase(parent)
{
//	m_staticTextMain->SetLabel("str");
}

void CAboutDialog::OnButtonOK(wxCommandEvent& event)
{
//    EndModal(false);
}

CEditDialog::CEditDialog(wxWindow* parent) : CEditDialogBase(parent)
{
}

void CreateMainWindow()
{
    pframeMain = new CMainFrame(NULL);
    pframeMain->Show(true);  // have to show first to get taskbar button to hide
}

// Define a new application
class CMyApp : public wxApp
{
public:
    CMyApp(){};
    ~CMyApp(){};
    bool OnInit();
};

IMPLEMENT_APP(CMyApp)

bool CMyApp::OnInit()
{
	SetAppName("Forth");
    return AppInit(argc, argv);
}
