// Copyright (c) 2009-2010 Satoshi Nakamoto
// Distributed under the MIT/X11 software license, see the accompanying
// file license.txt or http://www.opensource.org/licenses/mit-license.php.
#ifndef BITCOIN_UI_H
#define BITCOIN_UI_H

//#include <boost/function.hpp>

DECLARE_EVENT_TYPE(wxEVT_UITHREADCALL, -1)

void MainFrameRepaint();
void CreateMainWindow();

class CMainFrame : public CMainFrameBase
{
protected:
    // Event handlers
//    void OnNotebookPageChanged(wxNotebookEvent& event);
    void OnClose(wxCloseEvent& event);
    void OnPaintListCtrl(wxPaintEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnMenuFileExit(wxCommandEvent& event);
    void OnMenuHelpAbout(wxCommandEvent& event);
    void OnEdit(wxCommandEvent& event);
	
public:
    /** Constructor */
    CMainFrame(wxWindow* parent);
    ~CMainFrame();

    int nPage;
    wxListCtrl* m_listCtrl;


};


class CAboutDialog : public CAboutDialogBase
{
protected:
    // Event handlers
    void OnButtonOK(wxCommandEvent& event);

public:
    /** Constructor */
    CAboutDialog(wxWindow* parent);
};

extern char volatile TermOutBuff[];
extern char* volatile STR_ZTYPE;
extern char volatile KEY_VAR;
extern wxTextCtrl* m_wxTextCtrl24;

class CEditDialog : public CEditDialogBase
{
public:
    /** Constructor */
    CEditDialog(wxWindow* parent);
};


#endif
