
#include "uibase.h"
#include "xpm/edit.xpm"

///////////////////////////////////////////////////////////////////////////

CMainFrameBase::CMainFrameBase( wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style ) : wxFrame( parent, id, title, pos, size, style )
{
	this->SetSizeHints( wxDefaultSize, wxDefaultSize );
	this->SetBackgroundColour( wxSystemSettings::GetColour( wxSYS_COLOUR_BTNFACE ) );
	
	m_menubar = new wxMenuBar( 0 );
	m_menuFile = new wxMenu();
	wxMenuItem* m_menuFileExit;
	m_menuFileExit = new wxMenuItem( m_menuFile, wxID_EXIT, wxString( _("E&xit") ) , wxEmptyString, wxITEM_NORMAL );
	m_menuFile->Append( m_menuFileExit );
	
	m_menubar->Append( m_menuFile, _("&File") );
	m_menuHelp = new wxMenu();
	wxMenuItem* m_menuHelpAbout;
	m_menuHelpAbout = new wxMenuItem( m_menuHelp, wxID_ABOUT, wxString( _("&About...") ) , wxEmptyString, wxITEM_NORMAL );
	m_menuHelp->Append( m_menuHelpAbout );
	
	m_menubar->Append( m_menuHelp, _("&Help") );
	
	this->SetMenuBar( m_menubar );
	
	m_toolBar = this->CreateToolBar( wxTB_FLAT|wxTB_HORZ_TEXT, wxID_ANY );
	m_toolBar->AddTool( wxID_EDIT, _("TstEdit"), wxBitmap( edit_xpm ), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString );

	m_toolBar->Realize();
	
	m_statusBar = this->CreateStatusBar( 1, wxST_SIZEGRIP, wxID_ANY );

	
	m_forth = new wxTextCtrl( this, wxID_TEXTCTRLPAYTO, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE );
	this->Layout();
	
    wxFont fontTmp = m_forth->GetFont();
    fontTmp.SetFamily(wxFONTFAMILY_TELETYPE);
    m_forth->SetFont(fontTmp);

	// Connect Events
	this->Connect( wxEVT_CLOSE_WINDOW, wxCloseEventHandler( CMainFrameBase::OnClose ) );
	this->Connect( m_menuFileExit->GetId(), wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( CMainFrameBase::OnMenuFileExit ) );
	this->Connect( m_menuHelpAbout->GetId(), wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( CMainFrameBase::OnMenuHelpAbout ) );
	this->Connect( wxID_EDIT, wxEVT_COMMAND_TOOL_CLICKED, wxCommandEventHandler( CMainFrameBase::OnEdit ) );

	m_forth->Connect( wxEVT_KEY_DOWN, wxKeyEventHandler( CMainFrameBase::OnKeyDown ), NULL, this );
	m_forth->Connect( wxEVT_PAINT, wxPaintEventHandler( CMainFrameBase::OnPaintListCtrl ), NULL, this );

}

CMainFrameBase::~CMainFrameBase()
{
	// Disconnect Events
	this->Disconnect( wxEVT_CLOSE_WINDOW, wxCloseEventHandler( CMainFrameBase::OnClose ) );
	this->Disconnect( wxID_ANY, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler( CMainFrameBase::OnMenuHelpAbout ) );
	this->Disconnect( wxID_EDIT, wxEVT_COMMAND_TOOL_CLICKED, wxCommandEventHandler( CMainFrameBase::OnEdit ) );
}

CAboutDialogBase::CAboutDialogBase( wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style ) : wxDialog( parent, id, title, pos, size, style )
{
 	this->SetSizeHints( wxDefaultSize, wxDefaultSize );
}

CAboutDialogBase::~CAboutDialogBase(){}

wxTextCtrl* m_wxTextCtrl24=NULL;
wxTextCtrl* m_forth=NULL;
char volatile TermOutBuff[257];
char* volatile STR_ZTYPE=NULL;
char volatile KEY_VAR;


char ztbuffer [50];
int ztcount=0;

 void volatile WX_ZTYPE(char* cc)
{   wxPaintEvent event;
if(m_forth)
 {
	STR_ZTYPE=cc;
    m_forth->GetEventHandler()->AddPendingEvent(event);
    while(STR_ZTYPE);
 }
}

void WX_EMIT(char cc)
{
	char lc[2];
	lc[0]=cc;
	lc[1]=0;
	WX_ZTYPE((char*)&lc);

//	WX_ZTYPE(cc);
}

void WX_SPACE()
{
	WX_ZTYPE(" ");
}

int WX_ACCEPT(void *dst, size_t nn)
{  TermOutBuff[0]=0;
	while(TermOutBuff[0]==0) usleep(100);
	memcpy(dst,(char*)TermOutBuff, nn);
	return( strlen((char*)(dst)) );
}

char C_KEY()
{	KEY_VAR=0;
	while(!KEY_VAR) usleep(99);
	return KEY_VAR;
}


char C_TIB[111];
//extern "C" void    wxmain();
extern "C" void    bmain();

void ThreadForth(void* parg)
{
//	while(m_wxTextCtrl24==NULL) sleep(1);
	while(m_forth==NULL) sleep(1);
//	wxmain();
	bmain();
	for(;;)
	{

	WX_ACCEPT(C_TIB,111);
//	    Sleep(500);
	    WX_ZTYPE("cc=(");
	    WX_ZTYPE(C_TIB);
	    WX_SPACE();
//	    WX_ZTYPE("z");
//	    WX_EMIT(C_KEY()+'0');	    WX_EMIT('#');
//	    WX_ZTYPE((char*)TermOutBuff);
	    WX_ZTYPE(")");

	}
//        for(;;) WX_EMIT(C_KEY());
}


CEditDialogBase::CEditDialogBase( wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style ) : wxDialog( parent, id, title, pos, size, style )
{
	this->SetSizeHints( wxDefaultSize, wxDefaultSize );

	m_wxTextCtrl24 = new wxTextCtrl( this, wxID_TEXTCTRLPAYTO, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE );
	m_wxTextCtrl24->Connect( wxEVT_KEY_DOWN, wxKeyEventHandler( CEditDialogBase::OnKeyDown ), NULL, this );
	m_wxTextCtrl24->Connect( wxEVT_PAINT, wxPaintEventHandler( CEditDialogBase::OnPaintListCtrl ), NULL, this );

	this->Layout();
}

CEditDialogBase::~CEditDialogBase()
{	m_wxTextCtrl24->Disconnect( wxEVT_KEY_DOWN, wxKeyEventHandler( CEditDialogBase::OnKeyDown ), NULL, this );
	m_wxTextCtrl24->Disconnect( wxEVT_PAINT, wxPaintEventHandler( CEditDialogBase::OnPaintListCtrl ), NULL, this );
	m_wxTextCtrl24=NULL;
}
