
#ifndef __uibase__
#define __uibase__

#include <wx/intl.h>

#include <wx/string.h>
#include <wx/bitmap.h>
//#include <wx/image.h>
#include <wx/icon.h>
#include <wx/menu.h>
#include <wx/gdicmn.h>
#include <wx/font.h>
#include <wx/colour.h>
#include <wx/settings.h>
#include <wx/toolbar.h>
#include <wx/statusbr.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/sizer.h>
#include <wx/choice.h>
#include <wx/listctrl.h>
#include <wx/panel.h>
//#include <wx/notebook.h>
#include <wx/frame.h>
//#include <wx/html/htmlwin.h>
#include <wx/dialog.h>
#include <wx/listbox.h>
//#include <wx/checkbox.h>
//#include <wx/scrolwin.h>
//#include <wx/statbmp.h>

///////////////////////////////////////////////////////////////////////////

#define wxID_MAINFRAME 1000
#define wxID_BUTTONSEND 1001
#define wxID_BUTTONRECEIVE 1002
#define wxID_TEXTCTRLADDRESS 1003
#define wxID_BUTTONNEW 1004
#define wxID_BUTTONCOPY 1005
#define wxID_PROXYIP 1006
//#define wxID_PROXYPORT 1007
#define wxID_TRANSACTIONFEE 1008
#define wxID_TEXTCTRLPAYTO 1009
#define wxID_BUTTONPASTE 1010
#define wxID_BUTTONADDRESSBOOK 1011
#define wxID_TEXTCTRLAMOUNT 1012
#define wxID_CHOICETRANSFERTYPE 1013
#define wxID_LISTCTRL 1014
#define wxID_BUTTONRENAME 1015
#define wxID_PANELSENDING 1016
#define wxID_LISTCTRLSENDING 1017
#define wxID_PANELRECEIVING 1018
#define wxID_LISTCTRLRECEIVING 1019
#define wxID_BUTTONDELETE 1020
#define wxID_BUTTONEDIT 1021
#define wxID_TEXTCTRL 1022
#define wxID_EDIT 1023

extern wxTextCtrl* m_forth;
///////////////////////////////////////////////////////////////////////////////
/// Class CMainFrameBase
///////////////////////////////////////////////////////////////////////////////
class CMainFrameBase : public wxFrame 
{
	private:
	
	protected:
		wxMenuBar* m_menubar;
		wxMenu* m_menuFile;
		wxMenu* m_menuHelp;
		wxToolBar* m_toolBar;

		wxChoice* m_choiceFilter;
		
		// Virtual event handlers, overide them in your derived class
		virtual void OnClose( wxCloseEvent& event ) { event.Skip(); }
		virtual void OnMenuFileExit( wxCommandEvent& event ) { event.Skip(); }
		virtual void OnMenuHelpAbout( wxCommandEvent& event ) { event.Skip(); }
		virtual void OnEdit( wxCommandEvent& event ) { event.Skip(); }
		virtual void OnButtonAddressBook( wxCommandEvent& event ) { event.Skip(); }
		virtual void OnKeyDown( wxKeyEvent& event ) { event.Skip(); }
		virtual void OnListColBeginDrag( wxListEvent& event ) { event.Skip(); }
		virtual void OnListItemActivated( wxListEvent& event ) { event.Skip(); }
		virtual void OnPaintListCtrl( wxPaintEvent& event ) { event.Skip(); }

		
		public:
		wxMenu* m_menuOptions;
		wxStatusBar* m_statusBar;
		wxListCtrl* m_listCtrlAll;
		wxListCtrl* m_listCtrlReceived;
		
		CMainFrameBase( wxWindow* parent, wxWindowID id = wxID_MAINFRAME, const wxString& title = _("GTK4th"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxSize( 723,484 ), long style = wxDEFAULT_FRAME_STYLE|wxRESIZE_BORDER|wxTAB_TRAVERSAL );
		~CMainFrameBase();
	
};

///////////////////////////////////////////////////////////////////////////////
/// Class CAboutDialogBase
///////////////////////////////////////////////////////////////////////////////
class CAboutDialogBase : public wxDialog 
{

	protected:

		wxStaticText* m_staticTextMain;


	public:
//		wxStaticText* m_staticTextVersion;
		
		CAboutDialogBase( wxWindow* parent, wxWindowID id = wxID_ANY, const wxString& title = _("About GTK4th"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxSize( 532,333 ), long style = wxDEFAULT_DIALOG_STYLE );
		~CAboutDialogBase();
	
};

class CEditDialogBase : public wxDialog
{
	protected:
	virtual void OnKeyDown( wxKeyEvent& event ) { event.Skip(); }
	virtual void OnPaintListCtrl( wxPaintEvent& event ) { event.Skip(); }

	public:

		CEditDialogBase( wxWindow* parent, wxWindowID id = wxID_ANY, const wxString& title = _("bimbo"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxSize( 532,333 ), long style = wxDEFAULT_DIALOG_STYLE );
		~CEditDialogBase();
};


#endif //__uibase__
