#ifndef BITCOIN_UTIL_H
#define BITCOIN_UTIL_H

inline pthread_t CreateThread(void(*pfn)(void*), void* parg, bool fWantHandle=false)
{
    pthread_t hthread = 0;
    int ret = pthread_create(&hthread, NULL, (void*(*)(void*))pfn, parg);
    if (ret != 0)
    {
        return (pthread_t)0;
    }
    if (!fWantHandle)
        return (pthread_t)-1;
    return hthread;
}


inline void ExitThread(unsigned int nExitCode)
{
    pthread_exit((void*)nExitCode);
}


#endif
